/*
 *	@(#) machdep.h 2.4 88/02/29 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987, 1988.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 *	Various machine dependent things
 */

/* PC/AT Floppy disk control  */
#define FLIOC		('F'<<8)
#define FLIOCFTRK	(FLIOC|1)	/* ioctl command to format a track */
#define FLIOCSIZE	(FLIOC|2)	/* ioctl command to get floppy size */
#define FLIOCPRT	(FLIOC|3)	/* ioctl command to turn on/off prtfs */

/* PC/AT Floppy tape control  */
#define	MTIO			('T' << 8)
#define	MTTENSION		(MTIO | 1)	/* tension the tape */
#define	MTTAPE_STATUS		(MTIO | 2)	/* get tape status */
						/* (see return values below) */
#define	MTERASE_SERVO		(MTIO | 3)	/* erase the servo track */
#define	MTWRITE_SERVO		(MTIO | 4)	/* write the servo track */
#define	MTFORMAT_TRACK		(MTIO | 5)	/* format one tape track */
#define	MTBUILD_BTT		(MTIO | 6)	/* build the bad block table */
						/* and return the number of */
						/* good blocks */
#define	MTCART_TYPE		(MTIO | 7)	/* cartridge type	 */
#define	MTENABLE_BTT		(MTIO | 8)	/* enable bad track table */
#define	MTDISABLE_BTT		(MTIO | 9)	/* disable bad track table */
#define	MTENABLE_ECC		(MTIO | 0xA)	/* enable ecc		 */
#define	MTDISABLE_ECC		(MTIO | 0xB)	/* disable ecc		 */
#define	MTNUM_BB		(MTIO | 0xC)	/* change the number of bufs */
#define MTDC1000		(MTIO | 0xD)
#define MTDC2000		(MTIO | 0xE)

/* Drive types: */

#define	IRWIN_110		5		/* Irwin 10 M tape drive */
#define	IRWIN_145		6		/* Irwin 40 M tape drive */
#define IRWIN_125		7		/* Irwin 20 M tape drive */

/* Magnetic tape, return values from MTTAPE_STATUS ioctl call: */
#define	MTXENIX_TAPE		(MTIO | 32)	/* XENIX formatted tape */
#define	MTNOT_XENIX_TAPE	(MTIO | 33)	/* formatted tape, not */
						/* XENIX format */
#define	MTNO_SERVO		(MTIO | 34)	/* no servo track on tape */
#define	MTNOT_FORMATTED		(MTIO | 35)	/* servo track on tape, */

/* PC/AT Cga adapter control */
#define	CGAIOC	('C' << 8)	
#define	CGAMODE (CGAIOC | 1)		/* change cga mode */
#define CGAIO	(CGAIOC | 2)		/* do inb/outb on cga port */
#define CGA_GET (CGAIOC | 3)		/* get cga mode setting */

/* PC/AT Pga adapter control */
#define PGAIOC	('P' << 8)
#define PGAMODE (PGAIOC | 1)		/* change pga mode */
#define PGAIO	(PGAIOC | 2)		/* do inb/outb on pga port */
#define PGA_GET (PGAIOC | 3)		/* get pga mode setting */

/* PC/AT Ega adapter control */
#define EGAIOC	('E' << 8)
#define EGAMODE (EGAIOC | 1)		/* change ega mode */
#define EGAIO	(EGAIOC | 2)		/* do inb/outb on ega port */
#define EGA_GET (EGAIOC | 3)		/* get ega mode setting */
#define EGA_IOPRIVL (EGAIOC | 4)	/* get in/out privilege for ega ports */

/* PC/AT Mca adapter control */
#define MCAIOC	('M' << 8)
#define MCAMODE	(MCAIOC | 1)		/* change mca mode */
#define MCAIO	(MCAIOC | 2)		/* do inb/outb on mca port */
#define MCA_GET (MCAIOC | 3)		/* get mca mode setting */

/* Hercules support */
#define SW_HGC_P0  (MODESWITCH | M_HGC_P0)
#define SW_HGC_P1  (MODESWITCH | M_HGC_P1)

/* Common PC/AT adapter control */

#include "comcrt.h"

/* Defines for console-switching ioctl -- MONO, CGA, PGA, and EGA */
/* definitions are in comcrt.h  				  */	
#define SWAPCONS ('s' << 8)
#define SWAPMONO (SWAPCONS | MONO)
#define SWAPCGA  (SWAPCONS | CGA)
#define SWAPPGA  (SWAPCONS | PGA)
#define SWAPEGA  (SWAPCONS | EGA)

/* defines for mode-switching ioctl -- modes are defined in comcrt.h */
#define MODESWITCH ('S' << 8)
#define SW_B40x25  (MODESWITCH | M_B40x25)
#define SW_C40x25  (MODESWITCH | M_C40x25)
#define SW_B80x25  (MODESWITCH | M_B80x25)
#define SW_C80x25  (MODESWITCH | M_C80x25)
#define SW_BG320   (MODESWITCH | M_BG320)
#define SW_CG320   (MODESWITCH | M_CG320)
#define SW_BG640   (MODESWITCH | M_BG640)
#define SW_EGAMONO80x25 (MODESWITCH | M_EGAMONO80x25)
#define SW_CG320_D    (MODESWITCH | M_CG320_D)
#define SW_CG640_E    (MODESWITCH | M_CG640_E)
#define SW_EGAMONOAPA (MODESWITCH | M_EGAMONOAPA)
#define SW_CG640x350  (MODESWITCH | M_CG640x350)
#define SW_ENH_MONOAPA2 (MODESWITCH | M_ENHMONOAPA2)
#define SW_ENH_CG640  (MODESWITCH | M_ENH_CG640)
#define SW_ENHB40x25  (MODESWITCH | M_ENH_B40x25)
#define SW_ENHC40x25  (MODESWITCH | M_ENH_C40x25)
#define SW_ENHB80x25  (MODESWITCH | M_ENH_B80x25)
#define SW_ENHC80x25  (MODESWITCH | M_ENH_C80x25)
#define SW_ENHB80x43  (MODESWITCH | M_ENH_B80x43)
#define SW_ENHC80x43  (MODESWITCH | M_ENH_C80x43)
#define SW_MCAMODE    (MODESWITCH | M_MCA_MODE)

/* defines for display memory mapping ioctl (see consioctl in console.c) */
#define MAPADAPTER ('m' << 8)
#define MAPCONS (MAPADAPTER)  
#define MAPMONO (MAPADAPTER | MONO)
#define MAPCGA  (MAPADAPTER | CGA) 
#define MAPPGA  (MAPADAPTER | PGA)
#define MAPEGA  (MAPADAPTER | EGA)
#define MAPPGA1K  (MAPADAPTER | 0xff)

/* defines for ibm keyboard ioctls (see consioctl in console.c) */
#define FKEYIOC   ('k' << 8)
#define GETFKEY   (FKEYIOC)
#define SETFKEY   (FKEYIOC | 1)
#define TIOCKBON  (TIOC|8)
#define TIOCKBOF  (TIOC|9)
#define KBENABLED (TIOC|10)

#ifndef _GRAPHICS
#define _GRAPHICS
#define SW_MCAMODE    (MODESWITCH | M_MCA_MODE)

#ifdef M_I386
#pragma pack(2)
#endif

/* structure used for SETFKEY and GETFKEY ioctls */
struct fkeyarg {	
	unsigned short	keynum;
	char	 	keydef[MAXFK];
	char		flen;			
};

#ifdef M_I386
#pragma pack()
#endif

/* defines for ibm console ioctls (see consioctl in console.c) */
#define CONSIOC		('c' << 8)
#define CONS_CURRENT 	(CONSIOC|1)
#define CONS_GET	(CONSIOC|2)

/* defines for inb/outb ioctls for graphics adapter ports */
#define IN_ON_PORT	1
#define OUT_ON_PORT	0

#ifdef M_I386
#pragma pack(2)
#endif

/* structure used for inb/outb ioctls for graphics adapter ports */
struct port_io_struct {
	char	dir;	/* direction flag (in vs. out) */
	unsigned short port;
	char	data;
};
struct port_io_arg {
	struct port_io_struct args[4];
};	

#ifdef M_I386
#pragma pack()
#endif

#endif /* _GRAPHICS */

/* defines for Adaptec AHA-1540 ioctls */
#define	ADIOC		('a'<<8)
#define	ADFORMAT	(ADIOC|1)	/* format disk			*/
#define	ADMODESELECT	(ADIOC|2)	/* issue mode select		*/
#define	ADTEST		(ADIOC|3)	/* run diagnostics		*/
#define	ADBADSEC	(ADIOC|4)	/* set bad sector		*/
#define	ADTRACE		(ADIOC|5)	/* set diagnostic trace levels	*/
#define	ADMODESENSE	(ADIOC|6)	/* issue mode sense		*/
#define	ADBLOCKS	(ADIOC|97)	/* SNAP of blkno trace		*/
#define	ADSNAPMB	(ADIOC|98)	/* SNAP of driver mailboxes	*/
#define	ADSNAPCDB	(ADIOC|99)	/* SNAP of driver CDBs		*/


/*
 * Initalize clock constant for 50msec clock interrupts.
 * Magic value to cause proper interrupt interval.
 * Assumes a 1.193181MHz clock input. (1193181 / HZ)
 */

#define CLKNUM 23864

/* 
 * Various defines for 8259 special fully nested support
 */

/* Yes 3 is correct for certain systems running this kernel */
#define NUM_8259	3	/* number of 8259s on this system */

#define MAX8259		9 	/* max number of 8259s possible */
#define MAXLEV		8	/* max interrupt levels on an 8259 */
#define MAXVEC		72	/* max vectors on fully cascaded system */

#define	HAS_REBOOT	/* This system has a software reboot capability */

#define CTLR_16BIT	/* This system has a device controller that cannot */
		   	/* handle transfers across a 64k boundary. */

#define AUTOBOOT	/* This system has autoboot support */
#define	AUTOFLAG	0xbe11	/* 3rd argument to shutdn() */
