/*
 *	@(#) space.h 2.2 87/11/08 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */


/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL CPU'S AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

#ifdef M_I386
#include  "page.h"
#include  "init.h"
#endif

#include  "seg.h"
#include  "buf.h"
#include  "proc.h"
#include  "text.h"
#include  "signal.h"
#include  "mmu.h"
#include  "file.h"
#include  "inode.h"
#include  "map.h"
#include  "callo.h"
#include  "mount.h"
#include  "var.h"
#include  "systm.h"
#include  "utsname.h"

#include  "locking.h"
#include  "ipc.h"
#include  "sd.h"
#include  "msg.h"
#include  "sem.h"
#include  "emap.h"
#include  "sxt.h"

int Timezone=TIMEZONE;
int Dstflag=DSTFLAG;
int Cmask=CMASK;
int dma_single=DMAEXCL;

#ifdef M_I386
int memlim=MEMLIM;
int swplim=SWPLIM;
#endif

#ifndef M_I386

char sabuf[NSABUF][BSIZE];

#if NBUF==0
struct buf buf[MAXBUF];
#else
struct buf buf[NBUF+NSABUF];
#endif

#endif


#ifdef M_I386
struct	pfree	pfreelist;	/* Head of physio header pool */
struct	buf	pbuf[NPBUF];	/* Physical io header pool */
struct  pgstat  pgstat;
#endif

struct hbuf hbuf[NHBUF];	/* buffer hash table */

#ifdef M_I386
struct file file[NFILE];
struct inode inode[NINODE];
#else
struct file  far file[NFILE];
struct inode far inode[NINODE];
#endif

struct locklist locklist[NFLOCKS];

struct sd sdtab[NSDSEGS * NSDSLOTS];
struct shmid_ent shmid_tab[NSDSEGS];
int    shmid_pos;
struct proc proc[NPROC];
struct text text[NTEXT];
struct mapent coreent[CMAPSIZ];
struct map    coremap = {0, CMAPSIZ, coreent};

#ifdef M_I386
struct mapent sptent[100];
struct map    sptmap = {0, 100, sptent};
#else
struct mapent swapent[SMAPSIZ];
struct map    swapmap = {0, SMAPSIZ, swapent};
#endif

struct callo callout[NCALL];
struct cblock cfree[NCLIST];
struct mount mount[NMOUNT];
struct emap emap[NEMAP];
struct Link sxtlink[NSXT];

int Hz=HZ;

/* uts node name */
char node[SYS_NMLN] = NODE;

/* message facility */
struct	mapent		msgent[MSGMAP];
struct	map		msgmap = {0, MSGMAP, msgent};
struct  msqid_ds	msgque[MSGMNI];
struct	msg		msgh[MSGTQL];
struct	msginfo		msginfo = 
{
	MSGMAP,
	MSGMAX,
	MSGMNB,
	MSGMNI,
	MSGSSZ,
	MSGTQL,
	MSGSEG
};

/* System V semaphore facility */
struct	semid_ds	sema[SEMMNI];
struct	sem		sem[SEMMNS];
struct	mapent		sement[SEMMAP];
struct	map		semmap = {0, SEMMAP, sement};
struct	sem_undo	*sem_undo[NPROC];
#define SEMUSZ	(sizeof(struct sem_undo) + sizeof(struct undo) * SEMUME)
int	semu[((SEMUSZ * SEMMNU) + NBPW - 1) / NBPW];
union	
{
	ushort		semvals[SEMMSL];
	struct		semid_ds	ds;
	struct		sembuf		semops[SEMOPM];
}	semtmp;
struct	seminfo		seminfo =
{
	SEMMAP,
	SEMMNI,
	SEMMNS,
	SEMMNU,
	SEMMSL,
	SEMOPM,
	SEMUME,
	SEMUSZ,
	SEMVMX,
	SEMAEM,
};

#ifdef M_I386
struct  shminfo		shminfo386 =
{
	SHMMAX,
	SHMMIN,
	SHMMNI,
	SHMSEG,
	SHMBRK,
	SHMALL
};

struct  shminfo		shminfo286 =
{
	0x10000,
	1,
	SHMMNI,
	SHMSEG,
	SHMBRK,
	SHMALL
};
#endif

struct var v=
{
	NBUF,
	NSABUF,
	NHBUF,
	NHBUF-1,
	MAXBUF,
	NCALL,
	NINODE,
	&inode[NINODE],
	NFILE,
	&file[NFILE],
	NMOUNT,
	&mount[NMOUNT],
	NPROC,
	&proc[NPROC],
	NTEXT,
	&text[NTEXT],
	NCLIST,
	MAXUPRC,
	MAXMEM,
	NFLOCKS,
	NSDSEGS,
	NSDSLOTS,
	MSGMAP,
	MSGMAX,
	MSGMNB,
	MSGMNI,
	MSGTQL,
	MSGSSZ,
	MSGSEG,
	SEMMAP,
	SEMMNI,
	SEMMNU,
	SEMMSL,
	SEMOPM,
	SEMUME,
	SEMVMX,
	SEMAEM,
	SEMMNS,
	SEMUSZ,
	NSCRN,
	NPBUF,
	NEMAP,
	NSXT,
#ifdef  M_I386
	SHMMAX,
	SHMMIN,
	SHMMNI,
	SHMSEG,
	SHMBRK,
	SHMALL,
	NSDSEGS*NSDSLOTS,
#endif /* M_I386 */
};
