/*
 *	@(#) types.h 2.1 87/11/08 
 *
 *	Copyright (C) The Santa Cruz Operation, 1984, 1985, 1986, 1987.
 *	Copyright (C) Microsoft Corporation, 1984, 1985, 1986, 1987.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation, Microsoft Corporation
 *	and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

typedef	struct { int r[1]; }	*physadr;
typedef	long		daddr_t;
typedef	char		*caddr_t;
typedef	unsigned short	ushort;
typedef	unsigned short	ino_t;
typedef	char		cnt_t;
typedef	long		time_t;
#ifdef M_I386
typedef	int		label_t[6];	/* return, sp, si, di, bp */
#else
typedef	int		label_t[6];	/* return, sp, si, di, bp */
#endif
typedef	short		dev_t;
typedef	long		off_t;
typedef	unsigned long	paddr_t;
typedef	unsigned short	mloc_t;		/* memory region location */
typedef	unsigned short	msize_t;	/* memory region size */
typedef long		key_t;		/* IPC key	      */
typedef int 		pfn_t;

#ifdef M_I386
#define	inodep_t	struct inode *
#define	filep_t		struct file *
#else
#define	inodep_t	struct inode far *
#define	filep_t		struct file far *
#endif


/* 80286 special types */

#ifdef M_I286
#define	faddr_t		char far *
#define	fdesc_t		struct desctab far	/* far ldt entry */
#else
#define	faddr_t		char *		/* same as caddr_t for 8086/386 */
#endif


/* 'void' type compatibility */
#ifdef	M_OLDVOID
typedef	int	void;
#endif

/* 'unsigned' type compatibility */
#ifdef	M_OLDSIGN	/* { */

typedef	char	uchar_t;
typedef	long	ulong_t;

#define	GETUCHAR(uc)	(0xff & (uc))		/* extract value */
/* WARNING: you will lose the high bit */
#define	GETULONG(ul)	(0x7fffffffL & (ul))	/* extract value */

#else			/* }{ */

typedef unsigned char uchar_t;
typedef unsigned long ulong_t;
#define	GETUCHAR(uc)	(uc)
#define	GETULONG(ul)	(ul)

#endif			/* } */

struct saddr {			
	unsigned short	sa_seg;
	long		sa_off;
};
